// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/material.dart';
import 'package:gap/gap.dart';
import 'package:wyatt_ui_kit/wyatt_ui_kit.dart';

class SimpleIconButtons extends StatelessWidget {
  const SimpleIconButtons({super.key});

  @override
  Widget build(BuildContext context) => Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Text(
            'SimpleIcon Buttons',
            style: Theme.of(context).textTheme.titleMedium,
          ),
          const Gap(20),
          SimpleIconButton(
            icon: const Icon(
              Icons.storm_outlined,
              size: 17,
            ),
          ),
          const Gap(20),
          Text(
            'Enabled',
            style: Theme.of(context).textTheme.labelMedium,
          ),
          const Gap(10),
          SimpleIconButton(
            icon: const Icon(
              Icons.storm_outlined,
              size: 17,
            ),
          )
            ..bloc.enable()
            ..bloc.freeze(),
          const Gap(20),
          Text(
            'Disabled',
            style: Theme.of(context).textTheme.labelMedium,
          ),
          const Gap(10),
          SimpleIconButton(
            icon: const Icon(
              Icons.storm_outlined,
              size: 17,
            ),
          )
            ..bloc.disable()
            ..bloc.freeze(),
          const Gap(20),
          Text(
            'Hovered',
            style: Theme.of(context).textTheme.labelMedium,
          ),
          const Gap(10),
          SimpleIconButton(
            icon: const Icon(
              Icons.storm_outlined,
              size: 17,
            ),
          )
            ..bloc.onMouseEnter()
            ..bloc.freeze(),
          const Gap(20),
          Text(
            'Focused',
            style: Theme.of(context).textTheme.labelMedium,
          ),
          const Gap(10),
          SimpleIconButton(
            icon: const Icon(
              Icons.storm_outlined,
              size: 17,
            ),
          )
            ..bloc.onFocus()
            ..bloc.freeze(),
          const Gap(20),
          Text(
            'Tapped',
            style: Theme.of(context).textTheme.labelMedium,
          ),
          const Gap(10),
          SimpleIconButton(
            icon: const Icon(
              Icons.storm_outlined,
              size: 17,
            ),
          )
            ..bloc.onClickDown()
            ..bloc.freeze(),
          const Gap(20),
        ],
      );
}
